<template>
  <div>
    <DefaultHeaderPage />
    <div>
      <DefaultTable
        ref="tableRef"
        :columns="columns"
        :api-call="getUsers"
        :delete-function="deleteUser"
        :mostrar-selecao-de-colunas="false"
        :mostrar-botao-fullscreen="false"
        :mostrar-toggle-inativos="false"
        open-item
        add-item
        @on-row-click="onRowClick"
        @on-add-item="onAddItem"
      />
    </div>
  </div>
</template>

<script setup>
import { defineAsyncComponent, useTemplateRef } from "vue";
import { useQuasar } from "quasar";
import { useI18n } from "vue-i18n";
import { permissionStore } from "src/stores/permission";
import { getUsers, deleteUser } from "src/api/user";

import DefaultTable from "src/components/defaults/DefaultTable.vue";
import DefaultHeaderPage from "src/components/layout/DefaultHeaderPage.vue";

const AddEditUserDialog = defineAsyncComponent(
  () => import("src/pages/users/components/AddEditUserDialog.vue"),
);

const permission_store = permissionStore();
const $q = useQuasar();
const { t } = useI18n();
const tableRef = useTemplateRef("tableRef");

const columns = [
  {
    name: "nome",
    label: t("common.terms.name"),
    field: "name",
    align: "left",
    required: true,
    sortable: true,
  },
  {
    name: "email",
    label: "Email",
    field: "email",
    align: "left",
    sortable: true,
  },
  {
    name: "actions",
    required: true,
  },
];

const onRowClick = ({ row }) => {
  if (permission_store.getAccess("config.user", "view") === false) {
    $q.loading.hide();
    $q.notify({
      type: "negative",
      message: t("validation.permissions.view"),
    });
    return;
  }
  $q.dialog({
    component: AddEditUserDialog,
    componentProps: {
      user: row,
      title: () =>
        useI18n().t("common.actions.edit") + " " + useI18n().t("user.singular"),
    },
  }).onOk(async (success) => {
    if (success) {
      tableRef.value.refresh();
    }
  });
};

const onAddItem = () => {
  if (permission_store.getAccess("config.user", "add") === false) {
    $q.loading.hide();
    $q.notify({
      type: "negative",
      message: t("validation.permissions.add"),
    });
    return;
  }
  $q.dialog({
    component: AddEditUserDialog,

    componentProps: {
      title: () =>
        useI18n().t("common.actions.add") + " " + useI18n().t("user.singular"),
    },
  }).onOk(async (success) => {
    if (success) {
      tableRef.value.refresh();
    }
  });
};
</script>
